



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>margin-top失效的解决方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">margin-top失效的解决方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 10:30:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>异常处理汇总-前端系列&nbsp;<a href="http://www.cnblogs.com/dunitian/p/4523015.html" rel="external nofollow noreferrer">http://www.cnblogs.com/dunitian/p/4523015.html</a></p>
<p>我的是属于这种情况</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/658978/201603/658978-20160321180156979-1707396948.png" /></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/658978/201603/658978-20160321180207167-1944097447.png" /></p>
<p>按照网上的说法，我就是这个现象了</p>
<blockquote><p>两个层box1和box2，box1具有浮动属性，box2没有，这时候设置box2的上边距margin-top没有效果。</p></blockquote>
<p>这是网上的解决方法（并不适用我的情况）<a href="http://developer.51cto.com/art/201008/222728.htm" rel="external nofollow noreferrer">http://developer.51cto.com/art/201008/222728.htm</a></p>
<blockquote><p>本文向大家描述一下margin-top失效的解决方法，margin-top失效常出现两种情况来介绍，这里来和大家分享一下，希望本文的介绍一定会让你有所收获。</p>
<p><strong>关于margin-top失效的解决方法</strong></p>
<p>常出现两种情况：</p>
<p><strong>（一）margin-top失效</strong></p>
<p>先看下面代码：</p>
<ol><li>&lt;div&gt;</li>
<li>&lt;divclassdivclass="box1"&gt;float:left&lt;/div&gt;</li>
<li>&lt;divclassdivclass="box2"&gt;clear:both;margin-top:20px;&lt;/div&gt;</li>
<li>&lt;/div&gt;</li></ol>
<p>两个层box1和box2，box1具有浮动属性，box2没有，这时候设置box2的上边距margin-top没有效果。</p>
<p>网上能找到的两种比较靠谱的解释：</p>
<p>1：&ldquo;在CSS2.1中，水平的margin不会被折叠；垂直margin可能在一些盒模型中被折叠&hellip;&rdquo;</p>
<p>2：当第一个层浮动，而第二个没浮动层的margin会被压缩，详见--浮动元素后非浮动元素的margin的处理。</p>
<p>得到解决问题思路：要浮动一起浮动，要就一起不浮动。</p>
<p>◆解决办法：</p>
<p>1.box2增加float属性</p>
<p>2.box1与box2之间增加一层"&lt;divstyle="clear:both;"&gt;&lt;/div&gt;"</p>
<p>（二）子元素设置margin-top作用于父容器</p>
<ol><li>&lt;divclassdivclass="box"style="height:100px;background:red;"&gt;</li>
<li>&lt;divclassdivclass="box2"&gt;clear:both;</li>
<li>margin-top:20px;height:50px;width:500px;</li>
<li>background:#000;&lt;/div&gt;</li>
<li>&lt;/div&gt;</li></ol>
<p>当给box2设置margin-top时，在FF下仅作用于父容器。</p>
<p>◆解决办法：</p>
<p>1.给父容器box加overflow:hidden;属性</p>
<p>2.父容器box加border除none以外的属性</p>
<p>3.用父容器box的padding-top代替margin-top</p></blockquote>
<p>我的是这样解决的：</p>
<p><strong>直接设置父元素的margin-bottom：-20%;</strong></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/658978/201603/658978-20160321235131870-1026750293.png" /></p>
<p>后来为了漂亮，直接让他们全部浮动了，在橙色的div层使用取消浮动</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/658978/201603/658978-20160323161623479-840615460.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2k7glq.html">【bzoj1085】 SCOI2005&mdash;骑士精神</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvzd6x9.html">bugs</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdryk78.html">UrlRewrite&lpar;URL重写）--ASP&period;NET中的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvgjwzq.html">GZip压缩的js文件IE6下面不能包含&amp;lt&semi;script&amp;gt&semi;标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x74468.html">在idea中如何添加log日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjlyl49.html">《Programming WPF》翻译 第3章 1&period;什么是控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdvro78.html">Windows无需CygWin 使用NDK开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wrpelq.html">leetcode Jump Game II python</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg6e778.html">hdu2157矩阵快速幂</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyxy3m9.html">Kotlin 一个好用的新功能：Parcelize</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdvrmy9.html">项目实战10&period;1&mdash;企业级自动化运维工具应用实战-ansible</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pgm248.html">教你如何解决Sublime Text 3使用中出现的中文乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kploxj9.html">Spring中的&commat;scope注解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj6j11q.html">linux 显示当前所在文件位置 以及git 分支所在</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo0xjdq.html">3步永久性激活pycharm 亲测有效</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25moglq.html">css3 特效拓展 画个安卓机器人</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gyvweq.html">A glance for agile method</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwyowy8.html">linux&sol;centos6&period;5下编译安装python2&period;7和python3&period;5&period;2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvmogl8.html">Day7 错误和异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j13grg9.html">xdoj 1028 （素数线性筛&plus;dp&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq4zvw09.html">Thread与Runnable的一个小陷阱</a>
			</li>
						<li><a href="https://www.batexi.com/a/49ge7dl8.html">maven构建简单的web项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rg2lm8.html">Linux tricks</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnjxrj8.html">jsoup获取文档类示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96pv0j8.html">【内核篇】Windows内核重要变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7z63x9.html">iOS中 将 颜色转化成图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1ke249.html">PHP的数组排序函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2j7wx8.html">Python之路【第五篇】python基础 之初识函数（一）和文件管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxk0o08.html">Spark优化之三：Kryo序列化</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gj1ez9.html">System&period;Dynamic&period;ExpandoObject 类型的简单使用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
